package de.hft.stuttgart.citydoctor2.datastructure;

import de.hft.stuttgart.citydoctor2.utils.CopyHandler;
import de.hft.stuttgart.citydoctor2.utils.Copyable;
import org.citygml4j.core.model.building.BuildingFurnitureProperty;

import java.io.Serial;
import java.util.ArrayList;
import java.util.List;

public class BuildingRoom extends AbstractRoom{

    @Serial
    private static final long serialVersionUID = -276088332165299253L;
    private final List<BuildingFurnitureProperty> furnitureRefs = new ArrayList<>(2);
    private CityObject parent;

    public void setGmlObject(org.citygml4j.core.model.building.BuildingRoom cgmlRoom){
        super.cgmlRoom = cgmlRoom;
    }


    public void setParent(CityObject parent){
        this.parent = parent;
    }

    public void addFurnitureRef(BuildingFurnitureProperty furnitureRef) {
        furnitureRefs.add(furnitureRef);
    }

    /**
     * Returns the list of citygml3 furniture objects registered to this room.
     * The reference objects only hold a HRef to the actual furniture object.
     * @return
     */
    public List<BuildingFurnitureProperty> getFurnitureRefs() {
        return furnitureRefs;
    }

    public CityObject getParent() {
        return parent;
    }

    @Override
    public void fillValues(Copyable original, CopyHandler handler){
        super.fillValues(original, handler);

        BuildingRoom oRoom = (BuildingRoom) original;
        parent = handler.getCopyInstance(oRoom.getParent());
    }

    @Override
    public void collectInstances(CopyHandler handler){
        super.collectInstances(handler);
        handler.addInstance(parent);
    }

    @Override
    public Copyable createCopyInstance() {
        return new BuildingRoom();
    }
}
