package de.hft.stuttgart.citydoctor2.datastructure;


import de.hft.stuttgart.citydoctor2.utils.CopyHandler;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.Serial;
import java.util.HashMap;

/**
 * Reference object for handling of implicit geometries with a relative geometry
 */
public class RelativeGeometry extends Geometry {

    private static final Logger logger = LogManager.getLogger(RelativeGeometry.class);
    @Serial
    private static final long serialVersionUID = -686112245455298977L;

    private static HashMap<Geometry,RelativeGeometry> relativeGeometries = new HashMap<>();

    public static RelativeGeometry of(Geometry geom){
        if (relativeGeometries.containsKey(geom)){
            return relativeGeometries.get(geom);
        }
        RelativeGeometry relGeo = new RelativeGeometry(geom.getType(),geom.getLod());
        geom.getPolygons().forEach(relGeo::addPolygon);
        relGeo.updateEdgesAndVertices();
        relativeGeometries.put(geom,relGeo);
        return relGeo;
    }


    private RelativeGeometry(GeometryType type, Lod lod) {
        super(type, lod);
    }
}


